# This makes a blue_list array for you, that is, it makes an array of boxes that
# are not calculated. You can also have the blue field control code generated for
# you by choosing what type of control. The %w part is a shorthand way of indicating
# that all boxes are actually between double quotes and comma separated.
#
# What you need to do:
#
# 1) Copy the Ruby code that you want to create the list from via Ctrl-C.
# 2) Select what type of blue field control by setting the type to 't' for True
#	or 'f' for False - case does not matter. Make sure only one type is set to 't'. If you want
#	 just the box list then make sure all types are 'f' or you can remove any type code after
#	 the tool runs.
# 3) Then press F5 from SciTe while in this code file. Output goes to the output pane and it is
#	also copied to the clipboard.
#
# IMPORTANT: You will need to inspect the list for boxes that should not be in there,
# this will depend on your intended usage of the array. Hopefully you will not need to add any boxes.
#
#-#########################
#
# In this area select what type of blue field control you want to do.
# These types have been verified to convert to JS and function as expected.
#
#-#########################
#
# Set the box value to 0 if it is empty:
type1 = 't'

# Round the box value and append a decimal point if it is not empty.
type2 = 'f'

#-###################################################
#
# Beachtung! ndere nichts unter dieser Zeile! [Do not change anything below.....]
#
#-###################################################

require 'tk'

calcBoxArray = Array.new
calcsStr = TkClipboard.get(nil)

boxArray = calcsStr.scan(/box\d+_\d+/).uniq

calcsStr.scan(/\s*(box\d+_\d+) *=/).uniq.each do |boxAssign|
	calcBoxArray.push(boxAssign[0])
end

blueBoxArray = boxArray - calcBoxArray

#~ print "\n\n"
#~ p boxArray
#~ print "\n\n"
#~ p calcBoxArray
#~ print "\n\n"
#~ p blueBoxArray

# Make the %w{..} box list from the blueBoxArray

codeStr = ""

codeStr += "\n\nblue_list = %w{"

blueBoxArray.each do |box|
	codeStr += "#{box} "
end

codeStr = codeStr.chomp(" ") + "}\n\n"

# Now add the code based on which type of blue field control was selected else you get just the box list:
case
	when (type1.upcase == 'T')

		# Empty boxes are to display a zero '0'.
		codeStr += "blue_list.each do |x|\n\tprint x, eval(\"\#{x}.replace(\#{x}.to_f.round.to_s)\") if eval(\"\#{x}\").strip.empty?\nend\n\n"

	when (type2.upcase == 'T')

		# Round the box value and append a decimal point if it is not empty.
		codeStr += "blue_list.each do |x|\n\tprint x, eval(\"\#{x}.replace(\#{x}.to_f.round.to_s + '.')\") unless eval(\"\#{x}\").strip.empty?\nend\n\n"
end

#
# TkClipboard.set first clears the clipboard.
#
TkClipboard.set(codeStr.empty? ? '' : codeStr, nil)

print codeStr

